// GCMDSToolsDlg.cpp : 구현 파일
//

#include "stdafx.h"
#include "GCMDSTools.h"
#include "GCMDSToolsDlg.h"

#include "IniFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


INT GetProgramDir(char* buf, INT len ) 
{
	char* ProgDir;
	INT result;

	result = GetModuleFileName( theApp.m_hInstance, buf, len - 1 );
	if( result == 0 )
		return 0;

	char pgmPtr[1024];
	strcpy( pgmPtr, buf );

	ProgDir = buf;
	ProgDir += strlen( pgmPtr ) - 1;
	while( *ProgDir != '\\' && ProgDir != pgmPtr )
		ProgDir--;

	*ProgDir = 0;
	return (INT)strlen( buf );
}

BOOL BrowserFolder(char* szFolder)
{
	strcpy(szFolder, "");

	BROWSEINFO bi;

	bi.hwndOwner		= ::GetActiveWindow();
	bi.pidlRoot			= NULL;
	bi.pszDisplayName	= NULL;
	bi.lpszTitle        = "리스트에서 폴더를 선택하세요";
	bi.ulFlags		    = 0;
	bi.lpfn				= NULL;
	bi.lParam			= 0;

	LPITEMIDLIST pidl = SHBrowseForFolder( &bi );

	if( pidl == NULL )
		return FALSE;

	SHGetPathFromIDList( pidl, szFolder);

	LPMALLOC pMalloc;

	if( SHGetMalloc( &pMalloc ) != NOERROR )
		return FALSE;

	pMalloc->Free( pidl );
	pMalloc->Release();

	return TRUE;
}

// 응용 프로그램 정보에 사용되는 CAboutDlg 대화 상자입니다.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// 대화 상자 데이터입니다.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

// 구현입니다.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGCMDSToolsDlg 대화 상자




CGCMDSToolsDlg::CGCMDSToolsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGCMDSToolsDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGCMDSToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_KEY, m_Key);
	DDX_Control(pDX, IDC_INPUT, m_InDir);
	DDX_Control(pDX, IDC_OUTPUT, m_OutDir);
	DDX_Control(pDX, IDC_FILE, m_File);
	DDX_Control(pDX, IDC_CHECKMASK, m_2TypeMask);
}

BEGIN_MESSAGE_MAP(CGCMDSToolsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_INURL, &CGCMDSToolsDlg::OnBnClickedInurl)
	ON_BN_CLICKED(ID_OUTURL, &CGCMDSToolsDlg::OnBnClickedOuturl)
	ON_BN_CLICKED(ID_START, &CGCMDSToolsDlg::OnBnClickedStart)
	ON_CBN_SELCHANGE(IDC_KEY, &CGCMDSToolsDlg::OnCbnSelchangeKey)
	ON_BN_CLICKED(ID_START2, &CGCMDSToolsDlg::OnBnClickedStart2)
END_MESSAGE_MAP()


// CGCMDSToolsDlg 메시지 처리기

BOOL CGCMDSToolsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 이 대화 상자의 아이콘을 설정합니다. 응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.

	// TODO: 여기에 추가 초기화 작업을 추가합니다.
	m_Key.AddString("아무거나");
	m_Key.AddString("ROWGlobalKey");
	m_Key.AddString("Z_all_A_3D");
	m_Key.SetCurSel(0);

	m_File.AddString("GCMDS");
	m_File.AddString("skey");
	m_File.AddString("EDS");
	m_File.SetCurSel(0);
	

	LoadIni();

	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

VOID CGCMDSToolsDlg::LoadIni()
{
	char strBuff[512];
	GetProgramDir(strBuff, 512);

	strcat(strBuff, "\\Data.ini");

	CIniFile ini;
	if(!ini.Open(strBuff))
	{
		SaveIni();
		return;
	}

	DWORD lLen = 0;
	DWORD dwID = -1;
	char Data[512];
	ZeroMemory(Data, 512);
	if(ini.GetValue("GCMDS", "Key", &dwID))
		m_Key.SetCurSel(dwID);

	lLen = 0;
	ZeroMemory(Data, 512);
	if(ini.GetValue("GCMDS", "InputFolder", Data, &lLen) && lLen > 0)
		m_InDir.SetWindowText(Data);

	lLen = 0;
	ZeroMemory(Data, 512);
	if(ini.GetValue("GCMDS", "OutFolder", Data, &lLen) && lLen > 0)
		m_OutDir.SetWindowText(Data);

	ini.Close();
}

VOID CGCMDSToolsDlg::SaveIni()
{
	char strBuff[512];
	GetProgramDir(strBuff, 512);

	strcat(strBuff, "\\Data.ini");

	CIniFile ini;
	ini.Open(strBuff);

	char Data[512];
	DWORD dwID = m_Key.GetCurSel();
	ini.SetValue("GCMDS", "Key", dwID);

	m_InDir.GetWindowText(Data, 512);
	ini.SetValue("GCMDS", "InputFolder", Data);

	m_OutDir.GetWindowText(Data, 512);
	ini.SetValue("GCMDS", "OutFolder", Data);

	ini.Close();
}

void CGCMDSToolsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다. 문서/뷰 모델을 사용하는 MFC 응용 프로그램의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CGCMDSToolsDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CGCMDSToolsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CGCMDSToolsDlg::OnBnClickedInurl()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	// 입력 경로 지정
	char strBuff[512];
	BrowserFolder(strBuff);

	m_InDir.SetWindowText(strBuff);

	SaveIni();
}

void CGCMDSToolsDlg::OnBnClickedOuturl()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	// 출력 경로 지정
	char strBuff[512];
	BrowserFolder(strBuff);

	m_OutDir.SetWindowText(strBuff);

	SaveIni();
}


void CGCMDSToolsDlg::OnCbnSelchangeKey()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	SaveIni();
}

void CGCMDSToolsDlg::Recurse( CString perfolder )
{
	CString		str;
	CString		folder   = perfolder;

	char strKey[64];
	m_File.GetWindowText(strKey, 64);

	folder += "\\*.";
	folder += strKey;

	CFileFind finder;
	BOOL bWorking = finder.FindFile( folder );

	while( bWorking )
	{
		bWorking = finder.FindNextFile();

		if( finder.IsDots() )
			continue;

		CString path = finder.GetFilePath();
		if( finder.IsDirectory() )
			Recurse( path );
		else
		{
			m_FileList.push_back(path.GetBuffer());
		}

		Sleep( 1 );
	}
}

void CGCMDSToolsDlg::OnBnClickedStart()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	SaveIni();

	char strKey[32];
	m_Key.GetWindowText(strKey, 32);

	if(m_2TypeMask.GetCheck())
	{
		int iLen = strlen(strKey);
		for(int k = 0; k < iLen; ++k)
		{
			strKey[k] = strKey[k]^0xc8;
		}
	}

	m_FileList.clear();

	char strInDir[512];
	m_InDir.GetWindowText(strInDir, 512);

	Recurse(strInDir);

	char strInput[512];
	m_InDir.GetWindowText(strInput, 512);
	int iInputLen = (int)strlen(strInput);

	char strOut[512];
	m_OutDir.GetWindowText(strOut, 512);

	char strTemp[512];

	CString strCmdLine;

	char strExec[512];
	GetProgramDir(strExec, 512);
	strcat(strExec, "\\XORenc.exe");


	// 변환 시작
	int iSize = (int)m_FileList.size();
	for(int i = 0; i < iSize; ++i)
	{
		CString sIn = m_FileList[i];
		strcpy(strTemp, sIn);

		CString sOut = strOut;
		sOut += &strTemp[iInputLen];

		strCmdLine = '"'+sIn+'"'+" "+'"'+strKey+'"'+" "+'"'+sOut+'"';

		HINSTANCE nResult = ShellExecute(
		NULL,
		NULL, // do not request elevation unless needed
		strExec,
		strCmdLine, // params 
		NULL, // directory 
		SW_HIDE);
/*
		STARTUPINFO si;
		PROCESS_INFORMATION pi;
		ZeroMemory( &si, sizeof(si) );
		si.cb = sizeof(si);
		ZeroMemory( &pi, sizeof(pi) );
		CreateProcess( "XORenc.exe", (LPSTR)strCmdLine.GetString(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi );
*/
	}

	
	return;
}


void CGCMDSToolsDlg::OnBnClickedStart2()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	SaveIni();

	char strKey[32];
	m_Key.GetWindowText(strKey, 32);

	if(m_2TypeMask.GetCheck())
	{
		int iLen = strlen(strKey);
		for(int k = 0; k < iLen; ++k)
		{
			strKey[k] = strKey[k]^0xc8;
		}
	}

	m_FileList.clear();

	char strInDir[512];
	m_OutDir.GetWindowText(strInDir, 512);

	Recurse(strInDir);

	char strInput[512];
	m_OutDir.GetWindowText(strInput, 512);
	int iInputLen = (int)strlen(strInput);

	char strOut[512];
	m_InDir.GetWindowText(strOut, 512);

	char strTemp[512];

	CString strCmdLine;

	char strExec[512];
	GetProgramDir(strExec, 512);
	strcat(strExec, "\\XORenc.exe");


	// 변환 시작
	int iSize = (int)m_FileList.size();
	for(int i = 0; i < iSize; ++i)
	{
		CString sIn = m_FileList[i];
		strcpy(strTemp, sIn);

		CString sOut = strOut;
		sOut += &strTemp[iInputLen];

		strCmdLine = '"'+sIn+'"'+" "+'"'+strKey+'"'+" "+'"'+sOut+'"';

		HINSTANCE nResult = ShellExecute(
		NULL,
		NULL, // do not request elevation unless needed
		strExec,
		strCmdLine, // params 
		NULL, // directory 
		SW_HIDE);
/*
		STARTUPINFO si;
		PROCESS_INFORMATION pi;
		ZeroMemory( &si, sizeof(si) );
		si.cb = sizeof(si);
		ZeroMemory( &pi, sizeof(pi) );
		CreateProcess( "XORenc.exe", (LPSTR)strCmdLine.GetString(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi );
*/
	}


}
